Legrand / Raritan Xerus™ JSON-RPC API for Remote Access Devices like KX4-101, KX3G2

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | Public Attributes | List of all members
cert::ServerSSLCert Interface Reference

TLS certificate management interface. More...

`import "ServerSSLCert.idl";`

## Classes
struct | CertInfo
| Certificate information. More...
struct | CommonAttributes
| Certificate issuer or subject attributes. More...
struct | Info
| Certificate manager information. More...
struct | KeyInfo
| Public key information. More...
struct | ReqInfo
| Certificate signing request information. More...

## Public Types
enum | KeyType { KEY_TYPE_UNKNOWN , KEY_TYPE_RSA , KEY_TYPE_ECDSA }
| Supported key types. More...
enum | EllipticCurve { EC_CURVE_UNKNOWN , EC_CURVE_NIST_P256 , EC_CURVE_NIST_P384 , EC_CURVE_NIST_P521 }
| Supported elliptic curves for key type ECDSA. More...

## Public Member Functions
vector< KeyInfo > | getSupportedKeyInfos ()
| Get all supported key variants.
int | generateUnsignedKeyPair (in ReqInfo reqInfo, in string challenge)
| Generate an unsigned key pair.
int | generateSelfSignedKeyPair (in ReqInfo reqInfo, in int days)
| Generate a self-signed key pair.
void | deletePending ()
| Remove pending key and certificate signing request or certificate.
void | getInfo (out Info info)
| Retrieve certificate manager information.
string | getActiveCertChainPEM ()
| Get the active cert chain in PEM format.
string | getActiveKeyPEM (in string keyPassword)
| Get the active private key in PEM format.
string | getPendingRequestPEM ()
| Get the pending cert signing request (CSR) in PEM format.
string | getPendingCertChainPEM ()
| Get the pending cert chain in PEM format.
string | getPendingKeyPEM (in string keyPassword)
| Get the pending private key in PEM format.
int | setPendingCertChainPEM (in string certChain)
| Set the pending cert chain in PEM format.
int | setPendingKeyAndCertChainPEM (in string key, in string certChain, in string keyPassword)
| Set the pending private key and cert chain in PEM format.
int | installPendingKeyPair ()
| Activate a pending key pair.

## Public Attributes
constant int | SUCCESS = 0
| success code
constant int | ERR_BUSY = 1
| shared error codes
constant int | ERR_CSR_OR_CERT_PENDING = 101
constant int | ERR_KEY_MISSING = 200
constant int | ERR_CERT_MISSING = 201
constant int | ERR_CERT_FORMAT_INVALID = 202
constant int | ERR_CERT_KEY_MISMATCH = 203
constant int | ERR_KEY_FORMAT_INVALID = 204
constant int | ERR_GEN_KEY_LEN_INVALID = 100
| key-pair generation specific error codes
constant int | ERR_GEN_CSR_OR_CERT_PENDING = 101
| same as ERR_CSR_OR_CERT_PENDING
constant int | ERR_GEN_KEY_GEN_FAILED = 102
constant int | ERR_GEN_KEY_TYPE_INVALID = 103
constant int | ERR_GEN_ELLIPTIC_CURVE_INVALID = 104
constant int | ERR_GEN_VALIDITY_OUT_OF_RANGE = 105
constant int | ERR_INSTALL_KEY_MISSING = 200
| key-pair installation specific error codes (backward compatibility)
constant int | ERR_INSTALL_CERT_MISSING = 201
| same as ERR_CERT_MISSING
constant int | ERR_INSTALL_CERT_FORMAT_INVALID = 202
| same as ERR_CERT_FORMAT_INVALID
constant int | ERR_INSTALL_CERT_KEY_MISMATCH = 203
| same as ERR_CERT_KEY_MISMATCH
constant int | ERR_INSTALL_KEY_FORMAT_INVALID = 204

## Detailed Description

TLS certificate management interface.

Definition at line 12 of file ServerSSLCert.idl.

## Member Enumeration Documentation

## ◆ EllipticCurve

enum cert::ServerSSLCert::EllipticCurve

Supported elliptic curves for key type ECDSA.

Enumerator
EC_CURVE_UNKNOWN | Curve unknown (only allowed as return value)
EC_CURVE_NIST_P256 | NIST curve P-256 (also known as secp256r1 and prime256v1)
EC_CURVE_NIST_P384 | NIST curve P-384 (also known as secp384r1)
EC_CURVE_NIST_P521 | NIST curve P-521 (also known as secp521r1)

Definition at line 60 of file ServerSSLCert.idl.

## ◆ KeyType

enum cert::ServerSSLCert::KeyType

Supported key types.

Enumerator
KEY_TYPE_UNKNOWN | Key type unknown (only allowed as return value)
KEY_TYPE_RSA | RSA key.
KEY_TYPE_ECDSA | ECDSA key.

Definition at line 53 of file ServerSSLCert.idl.

## Member Function Documentation

## ◆ generateSelfSignedKeyPair()

int cert::ServerSSLCert::generateSelfSignedKeyPair | ( | in ReqInfo | reqInfo,
|  | in int | days )

Generate a self-signed key pair.

Parameters

  reqInfo | Certificate signing request information
  days | Number of days the certificate will be valid

Returns
  SUCCESS or one of the error code constants

## ◆ generateUnsignedKeyPair()

int cert::ServerSSLCert::generateUnsignedKeyPair | ( | in ReqInfo | reqInfo,
|  | in string | challenge )

Generate an unsigned key pair.

Parameters

  reqInfo | Certificate signing request information
  challenge | Challenge password

Returns
  SUCCESS or one of the error code constants

## ◆ getActiveCertChainPEM()

string cert::ServerSSLCert::getActiveCertChainPEM | ( |  | ) |

Get the active cert chain in PEM format.

Currently not available via JSON-RPC.

Returns
  Cert chain in PEM format.

## ◆ getActiveKeyPEM()

string cert::ServerSSLCert::getActiveKeyPEM | ( | in string | keyPassword | ) |

Get the active private key in PEM format.

Currently not available via JSON-RPC.

Parameters

  keyPassword | Password to encrypt the returned key (currently not used)

Returns
  The private key in PEM format.

## ◆ getInfo()

void cert::ServerSSLCert::getInfo | ( | out Info | info | ) |

Retrieve certificate manager information.

Parameters

  info | Result: Certificate manager information

## ◆ getPendingCertChainPEM()

string cert::ServerSSLCert::getPendingCertChainPEM | ( |  | ) |

Get the pending cert chain in PEM format.

Currently not available via JSON-RPC.

Returns
  Cert chain in PEM format.

## ◆ getPendingKeyPEM()

string cert::ServerSSLCert::getPendingKeyPEM | ( | in string | keyPassword | ) |

Get the pending private key in PEM format.

Currently not available via JSON-RPC.

Parameters

  keyPassword | Password to encrypt the returned key (currently not used)

Returns
  The private key in PEM format.

## ◆ getPendingRequestPEM()

string cert::ServerSSLCert::getPendingRequestPEM | ( |  | ) |

Get the pending cert signing request (CSR) in PEM format.

Currently not available via JSON-RPC.

Returns
  Cert signing request in PEM format.

## ◆ getSupportedKeyInfos()

vector< KeyInfo > cert::ServerSSLCert::getSupportedKeyInfos | ( |  | ) |

Get all supported key variants.

Returns
  Vector of KeyInfo structures representing all supported key variants

## ◆ installPendingKeyPair()

int cert::ServerSSLCert::installPendingKeyPair | ( |  | ) |

Activate a pending key pair.

Returns
  SUCCESS or one of the error code constants

## ◆ setPendingCertChainPEM()

int cert::ServerSSLCert::setPendingCertChainPEM | ( | in string | certChain | ) |

Set the pending cert chain in PEM format.

Currently not available via JSON-RPC.

Parameters

  certChain | Cert chain in PEM format.

Returns
  SUCCESS or one of the error code constants

## ◆ setPendingKeyAndCertChainPEM()

int cert::ServerSSLCert::setPendingKeyAndCertChainPEM | ( | in string | key,
|  | in string | certChain,
|  | in string | keyPassword )

Set the pending private key and cert chain in PEM format.

Currently not available via JSON-RPC.

Parameters

  key | Private key in PEM format.
  certChain | Cert chain in PEM format.
  keyPassword | Password to decrypt the private key (currently not used)

Returns
  SUCCESS or one of the error code constants

## Member Data Documentation

## ◆ ERR_BUSY

constant int cert::ServerSSLCert::ERR_BUSY = 1

shared error codes

Definition at line 18 of file ServerSSLCert.idl.

## ◆ ERR_CERT_FORMAT_INVALID

constant int cert::ServerSSLCert::ERR_CERT_FORMAT_INVALID = 202

Definition at line 22 of file ServerSSLCert.idl.

## ◆ ERR_CERT_KEY_MISMATCH

constant int cert::ServerSSLCert::ERR_CERT_KEY_MISMATCH = 203

Definition at line 23 of file ServerSSLCert.idl.

## ◆ ERR_CERT_MISSING

constant int cert::ServerSSLCert::ERR_CERT_MISSING = 201

Definition at line 21 of file ServerSSLCert.idl.

## ◆ ERR_CSR_OR_CERT_PENDING

constant int cert::ServerSSLCert::ERR_CSR_OR_CERT_PENDING = 101

Definition at line 19 of file ServerSSLCert.idl.

## ◆ ERR_GEN_CSR_OR_CERT_PENDING

constant int cert::ServerSSLCert::ERR_GEN_CSR_OR_CERT_PENDING = 101

same as ERR_CSR_OR_CERT_PENDING

Definition at line 28 of file ServerSSLCert.idl.

## ◆ ERR_GEN_ELLIPTIC_CURVE_INVALID

constant int cert::ServerSSLCert::ERR_GEN_ELLIPTIC_CURVE_INVALID = 104

Definition at line 31 of file ServerSSLCert.idl.

## ◆ ERR_GEN_KEY_GEN_FAILED

constant int cert::ServerSSLCert::ERR_GEN_KEY_GEN_FAILED = 102

Definition at line 29 of file ServerSSLCert.idl.

## ◆ ERR_GEN_KEY_LEN_INVALID

constant int cert::ServerSSLCert::ERR_GEN_KEY_LEN_INVALID = 100

key-pair generation specific error codes

Definition at line 27 of file ServerSSLCert.idl.

## ◆ ERR_GEN_KEY_TYPE_INVALID

constant int cert::ServerSSLCert::ERR_GEN_KEY_TYPE_INVALID = 103

Definition at line 30 of file ServerSSLCert.idl.

## ◆ ERR_GEN_VALIDITY_OUT_OF_RANGE

constant int cert::ServerSSLCert::ERR_GEN_VALIDITY_OUT_OF_RANGE = 105

Definition at line 32 of file ServerSSLCert.idl.

## ◆ ERR_INSTALL_CERT_FORMAT_INVALID

constant int cert::ServerSSLCert::ERR_INSTALL_CERT_FORMAT_INVALID = 202

same as ERR_CERT_FORMAT_INVALID

Definition at line 37 of file ServerSSLCert.idl.

## ◆ ERR_INSTALL_CERT_KEY_MISMATCH

constant int cert::ServerSSLCert::ERR_INSTALL_CERT_KEY_MISMATCH = 203

same as ERR_CERT_KEY_MISMATCH

Definition at line 38 of file ServerSSLCert.idl.

## ◆ ERR_INSTALL_CERT_MISSING

constant int cert::ServerSSLCert::ERR_INSTALL_CERT_MISSING = 201

same as ERR_CERT_MISSING

Definition at line 36 of file ServerSSLCert.idl.

## ◆ ERR_INSTALL_KEY_FORMAT_INVALID

constant int cert::ServerSSLCert::ERR_INSTALL_KEY_FORMAT_INVALID = 204

Definition at line 39 of file ServerSSLCert.idl.

## ◆ ERR_INSTALL_KEY_MISSING

constant int cert::ServerSSLCert::ERR_INSTALL_KEY_MISSING = 200

key-pair installation specific error codes (backward compatibility)

same as ERR_KEY_MISSING

Definition at line 35 of file ServerSSLCert.idl.

## ◆ ERR_KEY_FORMAT_INVALID

constant int cert::ServerSSLCert::ERR_KEY_FORMAT_INVALID = 204

Definition at line 24 of file ServerSSLCert.idl.

## ◆ ERR_KEY_MISSING

constant int cert::ServerSSLCert::ERR_KEY_MISSING = 200

Definition at line 20 of file ServerSSLCert.idl.

## ◆ SUCCESS

constant int cert::ServerSSLCert::SUCCESS = 0

success code

Definition at line 15 of file ServerSSLCert.idl.

The documentation for this interface was generated from the following file:

- ServerSSLCert.idl